# TODO
# - cleanup dead links from /etc/openssl/certs after -update uninstall
# - https://bugzilla.mozilla.org/show_bug.cgi?id=549701 and
#   http://groups.google.com/group/mozilla.dev.security.policy/browse_thread/thread/b6493a285ba79998#
# - add certs noted in TODO file
#
Summary:	Common CA Certificates PEM files
Summary(pl.UTF-8):	Pliki PEM popularnych certyfikatów CA
Name:		ca-certificates
Version:	20141019
Release:	1
License:	GPL v2 (scripts), MPL v2 (mozilla certs), distributable (other certs)
Group:		Libraries
Source0:	ftp://ftp.debian.org/debian/pool/main/c/ca-certificates/%{name}_%{version}.tar.xz
# Source0-md5:	f619282081c8bfc65ea64c37fa5285ed
Source1:	https://www.verisign.com/support/thawte-roots.zip
# Source1-md5:	21a284ebdc6e8f4178d5cc10fb9e1ef2
Source2:	http://www.certum.pl/keys/CA.pem
# Source2-md5:	35610177afc9c64e70f1ce62c1885496
Source3:	http://www.certum.pl/keys/level1.pem
# Source3-md5:	ba2d2e234ef9cfd2e6e5f810c964862e
Source4:	http://www.certum.pl/keys/level2.pem
# Source4-md5:	d06578a04e8cb23071f3870430ea0cf0
Source5:	http://www.certum.pl/keys/level3.pem
# Source5-md5:	47b67c63a52236576fc0d1150327c962
Source6:	http://www.certum.pl/keys/level4.pem
# Source6-md5:	f1f8a65d177745311a1e99f029ae5d71
Source7:	http://www.certum.pl/keys/vs.pem
# Source7-md5:	8da19ffc48c5dcc2868b1aa55f1d5983
Source8:	http://www.certum.pl/keys/na.pem
# Source8-md5:	ba571cb35e7672ff7ae95132ac1bfec4
Source9:	http://www.certum.pl/keys/tsa.pem
# Source9-md5:	1a7b3faf8ed00f4d80297de74862e102
Source10:	http://www.certum.pl/keys/class1.pem
# Source10-md5:	058436b132ea2df6972821f546104a16
Source11:	http://www.certum.pl/keys/class2.pem
# Source11-md5:	5caf7fe99b1fc6e63c40b3d081711d1b
Source12:	http://www.certum.pl/keys/class3.pem
# Source12-md5:	07bc97e21da092ba53535c7379e1b58b
Source13:	http://www.certum.pl/keys/class4.pem
# Source13-md5:	99ef61d509539af89f1c025b67245965
Source14:	http://crt.tcs.terena.org/TERENASSLCA.crt
# Source14-md5:	f62cd1546a8ef14e31ba1ce8eecd234a
Source15:	http://crt.tcs.terena.org/TERENAeScienceSSLCA.crt
# Source15-md5:	5feea35ab01a373f115219706f1f57bd
Source16:	http://crt.tcs.terena.org/TERENAPersonalCA.crt
# Source16-md5:	53eaa497c8fb0b79f14fe9f69693689a
Source17:	http://crt.tcs.terena.org/TERENAeSciencePersonalCA.crt
# Source17-md5:	e25cc655d3ebe920ca9c187e3dde9191
Source18:	http://crt.tcs.terena.org/TERENACodeSigningCA.crt
# Source18-md5:	74c9f511ab03a4e6b7462e310abfa89b
Source19:	http://www.sk.ee/upload/files/JUUR-SK.PEM.cer
# Source19-md5:	805784c06c9eff3771a4b9bd631cd3f5
Source20:	http://www.sk.ee/upload/files/ESTEID-SK.PEM.cer
# Source20-md5:	387beee5b8539ab7d91628f486295899
Source21:	http://www.sk.ee/upload/files/ESTEID-SK%202007.PEM.cer?/ESTEID-SK_2007.PEM.cer
# Source21-md5:	2b1a2a77f565d68fdf5f19f6cc3a5600
Source22:	http://www.sk.ee/upload/files/ESTEID-SK%202011.pem.cer?/ESTEID-SK_2011.pem.cer
# Source22-md5:	cfcc1e592cb0ff305158a7e32730546c
Patch0:		%{name}-undebianize.patch
Patch1:		%{name}-more-certs.patch
Patch2:		%{name}-etc-certs.patch
Patch3:		%{name}-c_rehash.sh.patch
Patch5:		%{name}-DESTDIR.patch
Patch6:		%{name}.d.patch
URL:		http://www.cacert.org/
BuildRequires:	openssl-tools
BuildRequires:	python
BuildRequires:	python-modules
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
BuildRequires:	unzip
BuildRequires:	xz
Obsoletes:	certificates
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		certsdir	/etc/certs
%define		openssldir	/etc/openssl/certs

%description
Common CA Certificates PEM files.

%description -l pl.UTF-8
Pliki PEM popularnych certyfikatów CA.

%package update
Summary:	Script for updating CA Certificates database
Summary(pl.UTF-8):	Skrypt do odświeżania bazy certyfikatów CA
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	mktemp
%if "%{pld_release}" == "ac"
Requires:	openssl-tools >= 0.9.7m-6.3
%else
Requires:	openssl-tools >= 0.9.8i-3
%endif

%description update
Script and data for updating CA Certificates database.

%description update -l pl.UTF-8
Skrypt i dane do odświeżania bazy certyfikatów CA.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch5 -p1
%patch6 -p1

%{__sed} -i -e 's,@openssldir@,%{openssldir},' sbin/update-ca-certificates*

%{__unzip} -qq %{SOURCE1} -d thawte

find thawte/ -name *.pem -o -name *.txt| while read f ; do
	if (file "$f" | grep -q "PEM"); then
		ff=$(echo $f | sed -e 's|[ ,]|_|g' -e 's|[()]|=|g')
		nname=$(basename "$ff" .pem)
		nname=$(basename "$nname" .txt)
		nname=$(basename "$nname" _b64)
		cp -pi "$f" "thawte/${nname}.crt"
	else
		echo "Skipping $f, doesn't look like PEM CERT"
	fi
done

install -d certum
cp -pi %{SOURCE2} certum
cp -pi %{SOURCE3} certum
cp -pi %{SOURCE4} certum
cp -pi %{SOURCE5} certum
cp -pi %{SOURCE6} certum
cp -pi %{SOURCE7} certum
cp -pi %{SOURCE8} certum
cp -pi %{SOURCE9} certum
cp -pi %{SOURCE10} certum
cp -pi %{SOURCE11} certum
cp -pi %{SOURCE12} certum
cp -pi %{SOURCE13} certum
for a in certum/*.pem; do
	mv -i "$a" "${a%.pem}.crt"
done

# http://www.sk.ee/en/Repository/certs/rootcertificates
# JUUR-SK, ESTEID-SK and ESTEID-SK 2007, ESTEID-SK 2011
install -d esteid
cp -pi %{SOURCE19} esteid
cp -pi %{SOURCE20} esteid
cp -pi %{SOURCE21} esteid/ESTEID-SK_2007.crt
cp -pi %{SOURCE22} esteid/ESTEID-SK_2011.crt
for a in esteid/*.PEM.cer; do
	mv -i "$a" "${a%.PEM.cer}.crt"
done

%build
install -d terena
openssl x509 -inform DER -in %{SOURCE14} -outform PEM -out terena/$(basename %{SOURCE14})
openssl x509 -inform DER -in %{SOURCE15} -outform PEM -out terena/$(basename %{SOURCE15})
openssl x509 -inform DER -in %{SOURCE16} -outform PEM -out terena/$(basename %{SOURCE16})
openssl x509 -inform DER -in %{SOURCE17} -outform PEM -out terena/$(basename %{SOURCE17})
openssl x509 -inform DER -in %{SOURCE18} -outform PEM -out terena/$(basename %{SOURCE18})

%{__make}

# We have those and more in specific dirs
rm mozilla/{Thawte,thawte,Certum,IGC_A,Deutsche_Telekom_Root_CA_2,Juur-SK}*.crt

# See TODO
# rm mozilla/RSA_Security_1024_v3.crt

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_datadir}/%{name},%{_sbindir},%{certsdir},/etc/pki/tls,%{_sysconfdir}/ca-certificates.d}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT%{_datadir}/ca-certificates -name '*.crt' -exec sed -i -e 's/\r$//' {} \;

(
cd $RPM_BUILD_ROOT%{_datadir}/ca-certificates
find . -name '*.crt' | sort | cut -b3-
) > $RPM_BUILD_ROOT%{_sysconfdir}/ca-certificates.conf

# build %{certsdir}/ca-certificates.crt
install -d $RPM_BUILD_ROOT%{openssldir}
./sbin/update-ca-certificates --destdir $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT%{openssldir}

%clean
rm -rf $RPM_BUILD_ROOT

%post update
%{_sbindir}/update-ca-certificates --fresh || :

%files
%defattr(644,root,root,755)
%doc debian/README.Debian debian/changelog
%dir /etc/pki/tls
%config(noreplace) %verify(not md5 mtime size) %{certsdir}/ca-certificates.crt

%files update
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/update-ca-certificates
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/ca-certificates.conf
%dir %{_sysconfdir}/ca-certificates.d
%{_datadir}/ca-certificates
%changelog
* Sat Nov 15 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ca-certificates.git;a=log;h=master

* Mon Nov 10 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> ab90db0
- up to 20141019

* Sat Oct 11 2014 Jakub Bogusz <qboosh@pld-linux.org> e54f061
- updated to 20140927

* Sun Mar 30 2014 Jakub Bogusz <qboosh@pld-linux.org> d7a6157
- updated to 20140325

* Fri Mar 14 2014 Elan Ruusamäe <glen@delfi.ee> fba66a4
- up to 20140223; cacert.org dropped

* Wed Sep 25 2013 Elan Ruusamäe <glen@delfi.ee> a4417de
- package /etc/pki/tls dir

* Fri Sep 13 2013 Elan Ruusamäe <glen@delfi.ee> 39ffd0e
- up to 20130906: Update mozilla/certdata.txt to version 1.94

* Tue Jun 11 2013 Elan Ruusamäe <glen@delfi.ee> 59b34d9
- ca-certificates (20130610) unstable; urgency=low

* Tue Apr 30 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 3c38a78
- rel 2; regenerate

* Thu Jan 24 2013 Jakub Bogusz <qboosh@pld-linux.org> 45b63c7
- updated to 20130119

* Sun Dec 02 2012 Elan Ruusamäe <glen@delfi.ee> f19958a
- up to 20121114, no changes to certs

* Sat Nov 10 2012 Elan Ruusamäe <glen@delfi.ee> 96dead2
- rpm5 treats # as comment, so it won't work in urls

* Thu Nov 08 2012 Elan Ruusamäe <glen@delfi.ee> 19100ce
- up to 20121105

* Thu Nov 08 2012 Elan Ruusamäe <glen@delfi.ee> 277121c
- %prep that depends BR moved to build

* Sun Sep 02 2012 Elan Ruusamäe <glen@delfi.ee> a848160
- release 4 (by relup.sh)

* Sun Sep 02 2012 Elan Ruusamäe <glen@delfi.ee> 9b4bd72
- use same paths on AC as on HEAD

* Wed Jun 27 2012 Elan Ruusamäe <glen@pld-linux.org> c26c606
- update to 20120623
- mozilla certs changed license to MPL-2.0
- mozilla/certdata.txt updated to version 1.81:
  Certificates added (+) and removed (-):
  + "Security Communication RootCA2"
  + "EC-ACC"
  + "Hellenic Academic and Research Institutions RootCA 2011"
  - "Verisign Class 2 Public Primary Certification Authority"
  - "Verisign Class 4 Public Primary Certification Authority - G2"
  - "TC TrustCenter, Germany, Class 2 CA"
  - "TC TrustCenter, Germany, Class 3 CA"

* Sat May 12 2012 Jan Rękorajski <baggins@pld-linux.org> 93ad0ea
- rel 2
- current version already contains all certs from mozilla

* Sat May 12 2012 Elan Ruusamäe <glen@pld-linux.org> 53d36f7
- add /etc/ca-certificates.d to support local certs, so there won't be need to edit package version of /etc/ca-certificates.conf, and thus no .rpmnew merge need

* Sat May 12 2012 Elan Ruusamäe <glen@pld-linux.org> 3dc5e4e
- up to 20120212, see changelog for added/removed ca-s

* Mon Sep 05 2011 Jacek Konieczny <jajcus@pld-linux.org> e06f46d
- Version: 20110502+nmu1 - blacklisted a compromised "DigiNotar Root CA" certificate

